/*
 * Toonloop
 *
 * Copyright 2010 Alexandre Quessy
 * <alexandre@quessy.net>
 * http://www.toonloop.com
 *
 * Toonloop is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Toonloop is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the gnu general public license
 * along with Toonloop.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef __IMAGE_H__
#define __IMAGE_H__

#include <string>

class Image 
{
    private:
        char *rawdata_;
        std::string name_;
        bool ready_;
    public: 
        Image(std::string name);
        ~Image();
        std::string get_name();
        char* get_rawdata();
        int allocate_image(int bufsize);
        bool is_ready();
        void set_ready(bool ready);
};

#endif // __IMAGE_H__

